<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 20/04/20
 * Time: 10.45
 */

namespace FiloBlu\Rma\Plugin\Model\Service;
use Psr\Log\LoggerInterface;
use Magento\Rma\Model\Rma;
use FiloBlu\Rma\Plugin\Model\RmaModelRmaProcessor;
use FiloBlu\Rma\Model\RmaEmailManagment;

class RmaManagmentProcessor
{

    /**
     * @var RmaModelRmaProcessor
     */
    private $rmaModelRmaProcessor;
    /**
     * @var Rma
     */
    private $rmaModel;
    /**
     * @var RmaEmailManagment
     */
    private $rmaEmailManagment;


    /**
     * RmaManagmentProcessor constructor.
     * @param LoggerInterface $logger
     * @param Rma $rmaModel
     * @param RmaModelRmaProcessor $rmaModelRmaProcessor
     * @param RmaEmailManagment $rmaEmailManagment
     */
    public function __construct(
        LoggerInterface $logger,
        Rma $rmaModel,
        RmaModelRmaProcessor $rmaModelRmaProcessor,
        RmaEmailManagment $rmaEmailManagment){
        $this->logger = $logger;
        $this->rmaModelRmaProcessor = $rmaModelRmaProcessor;
        $this->rmaModel = $rmaModel;
        $this->rmaEmailManagment = $rmaEmailManagment;
    }


    /**
     * @param \Magento\Rma\Model\Service\RmaManagement $subject
     * @param $result
     * @return \Magento\Rma\Model\Service\RmaManagement
     */
    public function afterSaveRma(\Magento\Rma\Model\Service\RmaManagement $subject, $result)
    {
        if ($result === false) {
            return $subject;
        }

        try {

            $rma = $this->rmaModel->load($result->getEntityId());
            $this->rmaModelRmaProcessor->afterSaveRma($rma,$result);
            if($result->getStatus() == 'pending'){
                $this->rmaEmailManagment->sendRmaEmail($result->getEntityId(),'pending');
            }
            return $result;
        } catch (\Exception $e) {
            $this->logger->critical($e->getMessage());
            return $result;
        }catch (\Throwable $t){
            $this->logger->critical($t->getMessage());
            return $result;
        }
    }






}